"use strict";
var browse_the_web_1 = require("../abilities/browse_the_web");
var Execute = (function () {
    function Execute() {
    }
    return Execute;
}());
Execute.script = function () {
    var lines = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        lines[_i] = arguments[_i];
    }
    return ({
        on: function (target) { return new ExecuteScript(lines, target); },
    });
};
Execute.asyncScript = function () {
    var lines = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        lines[_i] = arguments[_i];
    }
    return ({
        on: function (target) { return new ExecuteAsyncScript(lines, target); },
    });
};
exports.Execute = Execute;
var ExecuteScript = (function () {
    function ExecuteScript(lines, target) {
        this.lines = lines;
        this.target = target;
    }
    ExecuteScript.prototype.performAs = function (actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor).executeScript(this.lines.join('\n'), this.target);
    };
    return ExecuteScript;
}());
var ExecuteAsyncScript = (function () {
    function ExecuteAsyncScript(lines, target, args) {
        if (args === void 0) { args = []; }
        var _this = this;
        this.lines = lines;
        this.target = target;
        this.args = args;
        this.withArguments = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return new ExecuteAsyncScript(_this.lines, _this.target, args);
        };
    }
    ExecuteAsyncScript.prototype.performAs = function (actor) {
        return (_a = browse_the_web_1.BrowseTheWeb.as(actor)).executeAsyncScript.apply(_a, [this.lines.join('\n'), this.target].concat(this.args));
        var _a;
    };
    return ExecuteAsyncScript;
}());
exports.ExecuteAsyncScript = ExecuteAsyncScript;
//# sourceMappingURL=execute.js.map