"use strict";
var actor_1 = require("../screenplay/actor");
function describe_as(template) {
    var parameters = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        parameters[_i - 1] = arguments[_i];
    }
    var argument_tokens = /{(\d+)}/g, field_tokens = /#(\w+)/g, actor_token = '#actor', actor_name = parameters[0] instanceof actor_1.Actor ? parameters[0] : actor_token;
    var interpolated = field_tokens.test(template)
        ? template.replace(field_tokens, using(parameters[0]))
        : template.replace(argument_tokens, using(parameters));
    return interpolated.replace(actor_token, actor_name);
}
exports.describe_as = describe_as;
function using(source) {
    return function (token, field) { return stringify(token, source[field]); };
}
function stringify(token, value) {
    switch ({}.toString.call(value)) {
        case '[object Function]': return stringify(token, value());
        case '[object Array]': return value.map(function (item) { return stringify(token, item); }).join(', ');
        case '[object Object]': return value.toString();
        case '[object Undefined]': return token;
        default: return value;
    }
}
//# sourceMappingURL=activity_description.js.map