"use strict";
var TakeNotes = (function () {
    function TakeNotes(notepad) {
        var _this = this;
        this.notepad = notepad;
        this.note = function (topic, contents) { return (_this.notepad[topic] = contents, Promise.resolve()); };
    }
    TakeNotes.as = function (actor) {
        return actor.abilityTo(TakeNotes);
    };
    TakeNotes.prototype.read = function (topic) {
        return !!this.notepad[topic]
            ? Promise.resolve(this.notepad[topic])
            : Promise.reject(new Error("I don't have any notes on the topic of \"" + topic + "\""));
    };
    return TakeNotes;
}());
TakeNotes.usingAnEmptyNotepad = function () { return TakeNotes.using({}); };
TakeNotes.using = function (notepad) { return new TakeNotes(notepad); };
exports.TakeNotes = TakeNotes;
//# sourceMappingURL=take_notes.js.map