"use strict";
var config_1 = require("./config");
var stage_1 = require("./stage");
// todo: move to default config
exports.Default_Path_To_Reports = process.cwd() + "/target/site/serenity/";
var Serenity = (function () {
    function Serenity() {
        var _this = this;
        this.stage = new stage_1.Stage(new stage_1.StageManager(new stage_1.Journal()));
        this.configuration = new config_1.Config({
            cwd: process.cwd(),
            crew: [],
            parameters: {},
            stageCueTimeout: 30 * 1000,
        });
        this.callToStageFor = function (cast) { return _this.stage.enter(cast); };
        this.stageManager = function () { return _this.stage.manager; };
    }
    Serenity.prototype.notify = function (event) {
        this.stage.manager.notifyOf(event);
    };
    Serenity.prototype.configure = function (config) {
        var _this = this;
        this.configuration = new config_1.Config(config).withFallback(this.configuration.get);
        this.configuration.get.crew.forEach(function (crewMember) { return crewMember.assignTo(_this.stage); });
    };
    Object.defineProperty(Serenity.prototype, "config", {
        get: function () {
            return this.configuration.get;
        },
        enumerable: true,
        configurable: true
    });
    return Serenity;
}());
exports.Serenity = Serenity;
//# sourceMappingURL=serenity.js.map