"use strict";
var events_1 = require("../domain/events");
var moment = require("moment");
var util = require("util");
function consoleReporter(print) {
    if (print === void 0) { print = console.log; }
    return new ConsoleReporter(print);
}
exports.consoleReporter = consoleReporter;
var ConsoleReporter = (function () {
    function ConsoleReporter(print) {
        this.print = print;
    }
    ConsoleReporter.prototype.assignTo = function (stage) {
        this.stage = stage;
        this.stage.manager.registerInterestIn(ConsoleReporter.Events_of_Interest, this);
    };
    ConsoleReporter.prototype.notifyOf = function (event) {
        this.print(util.format('%s | %s: %s', moment(event.timestamp).format('HH:mm:ss.SSS'), event.constructor.name, event.value));
    };
    return ConsoleReporter;
}());
ConsoleReporter.Events_of_Interest = [events_1.DomainEvent];
exports.ConsoleReporter = ConsoleReporter;
//# sourceMappingURL=console_reporter.js.map